PVector[] p = {new PVector(350, 300), new PVector(70, 100), new PVector(200, 400)};
int t = 0;
PVector res;

import processing.serial.*;

String buff = "";
int NEWLINE = 10;
char stations[] = {'A','B','C'};
int freqs[] = new int[3];
int amps[] = new int[3];
int n;
Serial port;

void setup() {
  size(500,500);
  println("Available serial ports:");
  println(Serial.list());
  port = new Serial(this, Serial.list()[1], 9600);
}
void draw() {
  background(#FFFFFF);
  float multiplier = random(0.1,1.0);
  //float multiplier = 1 + sin(t * 2 * PI / 360) / 2;
  //t = t + 1 % 360;
  float[] v = new float[3];
  noFill();
  
  stroke(#000000);
  PVector mp = new PVector(mouseX, mouseY);
  for (int i = 0; i < p.length; ++i) {
    circle(p[i].x,p[i].y,3);
    v[i] = mp.dist(p[i]) * multiplier;
    //circle(p[i].x,p[i].y,v[i] * 2);
  }
  float m = max(v);
  int mi = 0;
  for (int i = 0; i < p.length; ++i) {
    if (v[i] == m) mi = i;
    v[i] = v[i]/m;
  }
  m = 200;
  
  float x = 0;
  float y = 0;
  for (int i = 0; i < 50; ++i) {
    float a1 = 0;
    float b1 = 0;
    float a2 = 0;
    float b2 = 0;
    for (int i1 = 0; i1 < p.length; ++i1) {
      int i2 = (i1 + 1) % 3;
      float x1 = p[i1].x;
      float y1 = p[i1].y;
      float v1 = v[i1]*m;
      float x2 = p[i2].x;
      float y2 = p[i2].y;
      float v2 = v[i2]*m;
      
      float d = p[i1].dist(p[i2]);
      float a = (sq(v1) - sq(v2) + sq(d)) / (2*d);
      float xc = x1 + (x2 - x1)/d*a;
      float yc = y1 + (y2 - y1)/d*a;
      //circle(xc,yc,3);
      
      stroke(#0000FF);
      //circle(x1,y1,v1);
      //float xc = (x1*v2+x2*v1)/(v1+v2);
      //float yc = (y1*v2+y2*v1)/(v1+v2);
      //circle(xc,yc,3);
      //line(x1,y1,x2,y2);
      stroke(#FF0000);
      a2 = a1;
      b2 = b1;
      a1 = (x2 - x1)/(y1 - y2);
      b1 = yc - (a1*xc);
      //line(xc - (y1 - y2)*10,yc - (x2 - x1)*10,xc + (y1 - y2)*10,yc + (x2 - x1)*10);
      //line(0,b1,500,b1+500*a1);
    }
    x = (b2 - b1)/(a1 - a2);
    y = a1 * x + b1;
    res = new PVector(x,y);
    float mnew = p[mi].dist(res);
    if (abs(m - mnew) < 1) break;
    m = mnew;
  }
  circle(x,y,3);
  stroke(#0000FF);
  for (int i = 0; i < p.length; ++i) {
    circle(p[i].x,p[i].y,p[i].dist(res)*2);
  }
}

void serialEvent(int serial) 
{ 
  try  {    // try-catch because of transmission errors
    if(serial != NEWLINE) { 
      buff += char(serial);
    } else {
      buff = buff.substring(0, buff.length()-1);// Discard the carriage return at the end of the buffer
      char station = buff.charAt(0); // The first character tells us which station the value is from
      buff = buff.substring(1); // Remove it from the string
      if (buff.charAt(0) != 'F') throw new Exception("Second character is not F");
      buff = buff.substring(1); // Remove it from the string
      String[] buff_split = split(buff,"A"); //Get the number before A (Frequency) and after (Amplitude)
      
      // Parse the String into two integers
      for(int z=0;z<3;z++) {
        if(station == stations[z]) {
          freqs[z] = Integer.parseInt(buff_split[0]);
          amps[z] = Integer.parseInt(buff_split[1]);
        }
      }
      buff = "";         // Clear the value of "buff"
    }
  }
  catch(Exception e) {
    println("no valid data:" + e);
  }
}
